# Eustia

Eustia is a tool for building your own JavaScript utility libraries. When we create a new project, usually the first thing we do is choosing a JavaScript library that provides useful programming helpers to make our lives easier. At this point, we think of open source JavaScript libraries such as underscore.js or lodash. However, there are times that we just want to use one or two of its functions. Moreover, the function helper we just need doesn't exist in it. And most of the time, we ended up extracting code from those libraries and writing extra helpers ourselves. This is the problem that Eustia is trying to solve.

## How it works

The tool will scan your source code to find strings that match the pattern `_.method` , then generates a JavaScript library containing only the methods you have used. It provides most of underscore's functions and some other useful small libraries, for example, ajax, Class, cookie helpers. You can also collect your own modules and methods to create libraries for multiple projects.

## Quick Example

You can install Eustia using Node Package Manager(`npm`).

    npm install -g eustia

Suppose you are doing a new project, and create a file name `index.html`. Then you want to use `trim` method in it, so you just write the code down as follows.

    <html>
    <head>
        <meta charset="utf-8"/>
        <title>Eustia</title>
    </head>
    <body>
        <script>
        var projectName = _.trim(' Eustia ');
        // Some code...
        </script>
    </body>
    </html>

Inside the same folder, run command:

    eustia index.html -o util.js

After that, just include the generated library in you html file. This is it, everything is just done, so simple!

    <script src="util.js"></script>

To view what methods Eustia currently supports, view the [src](https://github.com/liriliri/eustia/tree/master/src) directory. What's more, the project is a perfect example of using Eustia Whose [utility library](https://github.com/liriliri/eustia/blob/master/lib/util.js) is generated by itself.
